
import hk.quantr.routingalgo.lee.Path;
import hk.quantr.routingalgo.lee.Point;
import hk.quantr.routingalgo.lee.VerifyGrid;
import java.util.ArrayList;

/**
 *
 * @author Peter
 */
public class TestLee extends javax.swing.JFrame {

	VerifyGrid grid = new VerifyGrid(70);
	MyTableModel myTableModel = new MyTableModel();
	int testStartX = 10, testStartY = 10;
	int testEndX = 20, testEndY = 20;

	/**
	 * Creates new form TestLee
	 */
	public TestLee() {
		initComponents();
		this.setLocationRelativeTo(null);
	}

	/**
	 * This method is called from within the constructor to initialize the form. WARNING: Do NOT modify this code. The content of this method is always regenerated by the Form
	 * Editor.
	 */
	@SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jToolBar1 = new javax.swing.JToolBar();
        testButton = new javax.swing.JButton();
        clearButton = new javax.swing.JButton();
        setBlockToggleButton = new javax.swing.JToggleButton();
        setHorizontalWireToggleButton = new javax.swing.JToggleButton();
        setVerticalWireToggleButton = new javax.swing.JToggleButton();
        myPanel1 = new MyPanel();
        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jPanel2 = new javax.swing.JPanel();
        addEdgeButton = new javax.swing.JButton();
        deleteEdeButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Test Lee Algorithm");

        jToolBar1.setRollover(true);

        testButton.setText("Test");
        testButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                testButtonActionPerformed(evt);
            }
        });
        jToolBar1.add(testButton);

        clearButton.setText("Clear");
        clearButton.setFocusable(false);
        clearButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        clearButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        clearButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                clearButtonActionPerformed(evt);
            }
        });
        jToolBar1.add(clearButton);

        setBlockToggleButton.setText("Set Block");
        setBlockToggleButton.setFocusable(false);
        setBlockToggleButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        setBlockToggleButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        setBlockToggleButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                setBlockToggleButtonActionPerformed(evt);
            }
        });
        jToolBar1.add(setBlockToggleButton);

        setHorizontalWireToggleButton.setText("Set Horizontal Wire --");
        setHorizontalWireToggleButton.setActionCommand("SetWire");
        setHorizontalWireToggleButton.setFocusable(false);
        setHorizontalWireToggleButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        setHorizontalWireToggleButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        setHorizontalWireToggleButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                setHorizontalWireToggleButtonActionPerformed(evt);
            }
        });
        jToolBar1.add(setHorizontalWireToggleButton);

        setVerticalWireToggleButton.setText("Set Vertical Wire |");
        setVerticalWireToggleButton.setToolTipText("");
        setVerticalWireToggleButton.setFocusable(false);
        setVerticalWireToggleButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        setVerticalWireToggleButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        setVerticalWireToggleButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                setVerticalWireToggleButtonActionPerformed(evt);
            }
        });
        jToolBar1.add(setVerticalWireToggleButton);

        getContentPane().add(jToolBar1, java.awt.BorderLayout.PAGE_START);

        myPanel1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                myPanel1MouseClicked(evt);
            }
        });
        getContentPane().add(myPanel1, java.awt.BorderLayout.CENTER);

        jPanel1.setLayout(new java.awt.BorderLayout());

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane1.setViewportView(jTable1);

        jPanel1.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        addEdgeButton.setText("Add");
        addEdgeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addEdgeButtonActionPerformed(evt);
            }
        });
        jPanel2.add(addEdgeButton);

        deleteEdeButton.setText("Delete");
        jPanel2.add(deleteEdeButton);

        jPanel1.add(jPanel2, java.awt.BorderLayout.PAGE_END);

        getContentPane().add(jPanel1, java.awt.BorderLayout.EAST);

        setBounds(0, 0, 1143, 809);
    }// </editor-fold>//GEN-END:initComponents

    private void testButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_testButtonActionPerformed
		myPanel1.grid = grid;
//		ArrayList<hk.quantr.routingalgo.lee.Point> p = MyAlgorithm.myAlgorithm(grid, new hk.quantr.routingalgo.lee.Point(0, 0), new hk.quantr.routingalgo.lee.Point(10, 19), 20);

		grid.nodeLoc[5][0].applied = true;
		grid.nodeLoc[5][2].applied = true;
		grid.nodeLoc[5][3].applied = true;
		grid.nodeLoc[4][3].applied = true;
		grid.nodeLoc[3][3].applied = true;
		grid.nodeLoc[2][3].applied = true;
		grid.nodeLoc[1][3].applied = true;
		grid.nodeLoc[0][3].applied = true;
		grid.nodeLoc[0][9].applied = true;
		grid.nodeLoc[10][1].applied = true;
		grid.nodeLoc[5][6].applied = true;
		grid.nodeLoc[6][6].applied = true;
		grid.nodeLoc[7][6].applied = true;
		grid.nodeLoc[8][6].applied = true;
		grid.nodeLoc[9][6].applied = true;
		hk.quantr.routingalgo.lee.Point start = new hk.quantr.routingalgo.lee.Point(testStartX, testStartY);
		hk.quantr.routingalgo.lee.Point dest = new hk.quantr.routingalgo.lee.Point(testEndX, testEndY);
		Path temp = grid.findPath(start, dest, false);
		if (temp != null) {
			myPanel1.paths.add(temp);
			System.out.println(temp);
		}
		myPanel1.repaint();
    }//GEN-LAST:event_testButtonActionPerformed

    private void clearButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clearButtonActionPerformed
		grid.clear();
		myPanel1.paths.clear();
		myPanel1.repaint();
    }//GEN-LAST:event_clearButtonActionPerformed

    private void myPanel1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_myPanel1MouseClicked
		int x = evt.getX() / myPanel1.gridWidth;
		int y = evt.getY() / myPanel1.gridWidth;
		System.out.println(x + ", " + y);
		if (setBlockToggleButton.isSelected()) {
			grid.nodeLoc[x][y].applied = !grid.nodeLoc[x][y].applied;

			myPanel1.paths.clear();

			hk.quantr.routingalgo.lee.Point start = new hk.quantr.routingalgo.lee.Point(testStartX, testStartY);
			hk.quantr.routingalgo.lee.Point dest = new hk.quantr.routingalgo.lee.Point(testEndX, testEndY);
			Path temp = grid.findPath(start, dest, false);
			System.out.println(temp);
			if (temp != null) {
				myPanel1.paths.add(temp);
//				myPanel1.grid.applyPath(temp);
				System.out.println(temp);
			}
//			System.out.println();
			myPanel1.repaint();
		} else if (setHorizontalWireToggleButton.isSelected()) {
			grid.wireRow[x][y] = !grid.wireRow[x][y];
			myPanel1.paths.clear();
			hk.quantr.routingalgo.lee.Point start = new hk.quantr.routingalgo.lee.Point(testStartX, testStartY);
			hk.quantr.routingalgo.lee.Point dest = new hk.quantr.routingalgo.lee.Point(testEndX, testEndY);
			Path temp = grid.findPath(start, dest, false);
			System.out.println(temp);
			if (temp != null) {
				myPanel1.paths.add(temp);
//				myPanel1.grid.applyPath(temp);
				System.out.println(temp);
			}
//			System.out.println();
			myPanel1.repaint();
		} else if (setVerticalWireToggleButton.isSelected()) {
			grid.wireCol[x][y] = !grid.wireCol[x][y];
			myPanel1.paths.clear();
			hk.quantr.routingalgo.lee.Point start = new hk.quantr.routingalgo.lee.Point(testStartX, testStartY);
			hk.quantr.routingalgo.lee.Point dest = new hk.quantr.routingalgo.lee.Point(testEndX, testEndY);
			Path temp = grid.findPath(start, dest, false);
			System.out.println(temp);
			if (temp != null) {
				myPanel1.paths.add(temp);
//				myPanel1.grid.applyPath(temp);
				System.out.println(temp);
			}
//			System.out.println();
			myPanel1.repaint();
		}
    }//GEN-LAST:event_myPanel1MouseClicked

    private void addEdgeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addEdgeButtonActionPerformed
		myTableModel.paths.add(new Path(new Point(0, 0), new Point(1, 1), new ArrayList<Point>()));
		myTableModel.fireTableDataChanged();
    }//GEN-LAST:event_addEdgeButtonActionPerformed

    private void setBlockToggleButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_setBlockToggleButtonActionPerformed
		// TODO add your handling code here:
    }//GEN-LAST:event_setBlockToggleButtonActionPerformed

    private void setHorizontalWireToggleButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_setHorizontalWireToggleButtonActionPerformed
		// TODO add your handling code here:
    }//GEN-LAST:event_setHorizontalWireToggleButtonActionPerformed

    private void setVerticalWireToggleButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_setVerticalWireToggleButtonActionPerformed
		// TODO add your handling code here:
    }//GEN-LAST:event_setVerticalWireToggleButtonActionPerformed

	/**
	 * @param args the command line arguments
	 */
	public static void main(String args[]) {
		/* Set the Nimbus look and feel */
		//<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
		/* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
		 */
		try {
			for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
				if ("Nimbus".equals(info.getName())) {
					javax.swing.UIManager.setLookAndFeel(info.getClassName());
					break;
				}
			}
		} catch (ClassNotFoundException ex) {
			java.util.logging.Logger.getLogger(TestLee.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
		} catch (InstantiationException ex) {
			java.util.logging.Logger.getLogger(TestLee.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
		} catch (IllegalAccessException ex) {
			java.util.logging.Logger.getLogger(TestLee.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
		} catch (javax.swing.UnsupportedLookAndFeelException ex) {
			java.util.logging.Logger.getLogger(TestLee.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
		}
		//</editor-fold>

		/* Create and display the form */
		java.awt.EventQueue.invokeLater(new Runnable() {
			public void run() {
				new TestLee().setVisible(true);
			}
		});
	}

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addEdgeButton;
    private javax.swing.JButton clearButton;
    private javax.swing.JButton deleteEdeButton;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTable1;
    private javax.swing.JToolBar jToolBar1;
    private MyPanel myPanel1;
    private javax.swing.JToggleButton setBlockToggleButton;
    private javax.swing.JToggleButton setHorizontalWireToggleButton;
    private javax.swing.JToggleButton setVerticalWireToggleButton;
    private javax.swing.JButton testButton;
    // End of variables declaration//GEN-END:variables
}
